CREATE TABLE audit_prod(
username    TEXT,
timest      TIMESTAMP,
operation   CHAR(1),
prod_id     INTEGER,
category    INTEGER,
title       VARCHAR(50),
actor       VARCHAR(50),
price       NUMERIC(12,2),
special     SMALLINT,
c_prod_id   INTEGER);

CREATE OR REPLACE FUNCTION f_audit_prod()
RETURNS TRIGGER AS $audit_prod$
BEGIN
IF (TG_OP = 'DELETE') THEN
INSERT INTO audit_prod SELECT user, now(), 'D', OLD.*;
RETURN OLD;
ELSEIF (TG_OP = 'UPDATE') THEN
INSERT INTO audit_prod SELECT user, now(), 'U', NEW.*;
RETURN NEW;
ELSEIF (TG_OP = 'INSERT') THEN
INSERT INTO audit_prod SELECT user, now(), 'I', NEW.*;
RETURN NEW;
END IF;
RETURN NULL;
END;
$audit_prod$ LANGUAGE plpgsql;

CREATE TRIGGER tr_audit_prod
AFTER INSERT OR UPDATE OR DELETE ON products
FOR EACH ROW EXECUTE PROCEDURE f_audit_prod();
