CREATE OR REPLACE FUNCTION get_by_category()
RETURNS TEXT
AS $$
DECLARE
  text_output TEXT = E'\n';
  row_prod products%ROWTYPE;
BEGIN
  FOR row_prod IN SELECT p.* FROM products p, categories c WHERE p.category = c.category AND c.categoryname = 'Action' ORDER BY 1  LOOP
    text_output := text_output || row_prod.title || ' - ' || row_prod.actor || ' : ' || row_prod.price || E'\n';
  END LOOP;
  RETURN text_output;
END;
$$ LANGUAGE plpgsql;

SELECT get_by_category();
