CREATE FUNCTION inc_price(p_price NUMERIC)
RETURNS void
AS $$
DECLARE
  cur_products CURSOR(p_price NUMERIC)
    FOR SELECT * FROM products WHERE price <= p_price;
  rec_prod RECORD;
BEGIN
  OPEN cur_products(p_price);
  LOOP
    FETCH cur_products INTO rec_prod;
    EXIT WHEN NOT FOUND;
    RAISE NOTICE '% raising price', rec_prod.title;
    UPDATE products SET price = price + (price * 0.1)
      WHERE CURRENT OF cur_products;
  END LOOP;
  CLOSE cur_products;
END;
$$ LANGUAGE plpgsql;

SELECT inc_price(10);
