#include <stdlib.h>
#include <libpq-fe.h>
int main(int argc, char** argv) {
  printf(“SQL-Anweisung: %s\n”,argv[1]);
  PGresult *res;
  PGconn *myconn = PQconnectdb(“”);
  if (PQstatus(myconn) == CONNECTION_OK)
    printf(“Verbindung hergestellt\n”);
  else {
    printf(“Verbindung fehlgeschlagen\n”);
    printf(“Fehler: %s\n”, PQerrorMessage(myconn));
    }
  res = PQexec(myconn, argv[1]);
  switch(PQresultStatus(res)) {
  case PGRES_COMMAND_OK:
    printf(“Anweisung erfolgreich ausgefuehrt\n”);
    break;
  case PGRES_TUPLES_OK:
    printf(“Anweisung mit Resultset\n”);
    break;
  case PGRES_EMPTY_QUERY:
    printf(“Leere Anweisung\n”);
    break;
  case PGRES_FATAL_ERROR:
    printf(“Fehler\n”);
    break;
  }
  PQfinish(myconn);
  return EXIT_SUCCESS;
}
