#include <stdlib.h>
#include <libpq-fe.h>
int main(int argc, char** argv) {
  PGresult *res;
  int i=0;
  int j=0;
  int rows=0;
  int cols=0;
  PGconn *myconn = PQconnectdb(“”);
  if (PQstatus(myconn) == CONNECTION_OK)
    printf(“Verbindung hergestellt\n”);
  else {
    printf(“Verbindung fehlgeschlagen\n”);
    printf(“Fehler: %s\n”, PQerrorMessage(myconn));
  }
  res = PQexec(myconn, “SELECT * FROM categories”);
  switch(PQresultStatus(res)) {
    case PGRES_TUPLES_OK:
      rows = PQntuples(res);
      cols = PQnfields(res);
      printf(“Anzahl Zeilen: %d\n”, rows);
      printf(“Anzahl Spalten: %d\n”, cols);
      printf(“Tabellenstruktur:\n”);
      for(i = 0; i < cols; i++) {
        printf(“ %s: %d\n”, PQfname(res, i), PQfsize(res, i));
      }
      printf(“Daten:\n”);
      for (i = 0; i < rows; i++) {
        for (j = 0; j < cols; j++)
          printf(“ %s,”, PQgetvalue(res, i, j));
        printf(“\n”);
      }
      break;
    case PGRES_EMPTY_QUERY:
      printf(“Leere Anweisung\n”);
      break;
    case PGRES_FATAL_ERROR:
      printf(“Fehler\n”);
      break;
  }
  PQclear(res);
  PQfinish(myconn);
  return EXIT_SUCCESS;
}
