#include <stdlib.h>
#include <libpq-fe.h>
void runSQL(PGconn *conn, char *sqlcomm) {
  PGresult *result;
  printf(„ %s \n”, sqlcomm);
  result = PQexec(conn, sqlcomm);
  printf(“\nStatus: %s\n”, PQresStatus(PQresultStatus(result)));
  printf(“Number of rows: %s\n”, PQcmdTuples(result));
  printf(“Result: %s\n”, PQresultErrorMessage(result));
  switch(PQresultStatus(result)) {
  case PGRES_TUPLES_OK: {
    int i,j;
    int rows = PQntuples(result);
    int cols = PQnfields(result);
    for ( i = 0; i < rows; i++) {
      for ( j = 0; j < cols; j++)
        printf(“ %s = %s,”,PQfname(result,j),PQgetvalue(result,i,j));
      printf(“\n”);
      }
    }
  }
}
int main(int argc, char** argv) {
  PGresult *result;
  PGconn *conn;
  conn = PQconnectdb(“”);
  if(PQstatus(conn) == CONNECTION_OK) {
    printf(“Connection successful\n”);
    runSQL(conn, “BEGIN WORK”);
    runSQL(conn, “DECLARE sales_cursor CURSOR FOR SELECT * FROM sales”);
    runSQL(conn, “FETCH ALL IN sales_cursor”);
    runSQL(conn, “CLOSE sales_cursor”);
    runSQL(conn, “COMMIT WORK”);
  } else {
    printf(“Connection failed: %s\n”, PQerrorMessage(conn));
  }
  return EXIT_SUCCESS;
}
