#!/usr/bin/perl
use strict;
use DBI;
my $num_args = $#ARGV + 1;
if ($num_args gt 0) {
  print "\n usage: DBBulk\n";
  exit;
}
my $filename = 'Bulk_DBs.txt';
my $sqlfile = 'Bulk_SQL.txt';
my ($var1, $var2, $var3, $var4, $var5);
open (my $fh2, '<', $sqlfile)
  or die "Could not open file '$sqlfile' $!";
my $sqltext = do {local $/; <$fh2>};
close $fh2;         
print $sqltext,"\n","----------------------------------------------------", "\n";
open (my $fh, '<', $filename)
  or die "Could not open file '$filename' $!";
while (my $line = <$fh>) {
  chomp $line;
  ($var1, $var2, $var3, $var4, $var5) = split /\s+/, $line;
  printf ("%-12s: ", "$var1");
  &oneDB($var1, $var2, $var3, $var4, $var5, $sqltext);
}
close $fh;
# ----------------------------------- Subs ----------------------------------
sub oneDB {
  my $server = shift;
  my $port = shift;
  my $database = shift;
  my $username = shift;
  my $password = shift;
  my $sqltext = shift;
  my $db = &dbconnect($server, $port, $database, $username, $password);
  &runSQL($db, $sqltext);
}
sub runSQL {
  my $dbh = shift;
  my $sqltext = shift;
  my %result;
  my $row;
  my $sth = $dbh->prepare($sqltext) or print STDOUT "Query failed\n"; 
  $sth->execute;
  while ($row = $sth->fetchrow_arrayref) {
    print join (",", @{$row}), "|";
  }
  $sth->finish;
  print "\n";
}
sub dbconnect {
  my $server = shift;
  my $port = shift;
  my $database = shift;
  my $user = shift;
  my $password = shift;
  my $dbh=DBI->connect("dbi:Pg:database=$database;host=$server;port=$port" , $user , $password) or die $DBI::errstr;
  return $dbh;
}
