#!/usr/bin/perl
# Compare PostgreSQL databases - Light version
# perl PGSchemaComp.pl localhost hanser public localhost hanser2 public
use strict;
use DBI;
my $num_args = $#ARGV + 1;
if ($num_args lt 6) {
  print "\n usage: PGSchemaComp.pl hostname1 database1 schema1 hostname2 database2 schema2 \n";
  exit;
}
my $hostname1 = $ARGV[0];
my $database1 = $ARGV[1];
my $schema1 = $ARGV[2];
my $hostname2 = $ARGV[3];
my $database2 = $ARGV[4];
my $schema2 = $ARGV[5];
my %Unique_DB1; 
my %Unique_DB2; 
my $db1 = &dbconnect("$hostname1", "$schema1", "$database1");
my $db2 = &dbconnect("$hostname2", "$schema2", "$database2");
my $dt= &get_date_time($db1, $schema1, $database1);
print STDOUT "\n\nComparing : $database1.$schema1 - $database2.$schema2 $dt\n\n";
print "\nComparing Tables";
print "\n------------------";
&compare_tables;
# ----------------------------------- Subs ----------------------------------
sub compare_tables {
  my %Tables1 = &get_tables($db1, $schema1, $database1);
  my %Tables2 = &get_tables($db2, $schema2, $database2);
  my $key;
  my %TableDiff;
  foreach $key (keys %Tables1) {
    if ($Tables2{$key}) {
      } else {
        $TableDiff{Database_1}{$key} = 1;
         }
       }
  foreach $key (keys %Tables2) {
         unless ($Tables1{$key}) {
             $TableDiff{Database_2}{$key} = 1;
         }
       }
  print "\nTables not found in schema $database1.$schema1:\n";
  for $key (keys %{$TableDiff{Database_2}}) {
       print "$key\n";
  }
  print "\nTables not found in schema $database2.$schema2:\n";
  for $key (keys %{$TableDiff{Database_1}}) {
       print "$key\n";
  }
}
sub get_tables {
  my $dbh = shift;
  my $sch = shift;
  my $dbase = shift;
  my %tables;
  my $row;
  my $sqlstr = "SELECT relname, nspname AS full_rel_name FROM pg_class, 
pg_namespace WHERE relnamespace = pg_namespace.oid AND nspname = 'public' AND 
relkind = 'r'";
  my $sth = $dbh->prepare($sqlstr) or print STDOUT "get_tables:Query failed\n";
  $sth->execute;
  my $data = $sth->fetchall_arrayref;
  $sth->finish;
  print "\nNumber of tables in schema $dbase.$sch is ", 0 + @{$data}, "\n";
  foreach $row (@{$data}) {
       $tables{$row->[0]}{TableName} = $row->[0];
       $tables{$row->[1]}{Schema} = $row->[1];
  }
  return %tables;
}
sub get_date_time {
  my $dbh = shift;
  my $schema_name = shift;
  my $database_name = shift;
  my $sth = $dbh->prepare("SELECT now()");
  $sth->execute;
  my $dt = $sth->fetchrow_array;
  $sth->finish;
  return $dt;
}
sub dbconnect {
  my $hostname = shift;
  my $schema = shift;
  my $database = shift;
  my $dbh = DBI->connect("DBI:Pg:dbname=$database;host=$hostname;port=5432", "postgres", "") or die $DBI::errstr;; 
  return $dbh;
}
