CREATE OR REPLACE FUNCTION pivot_cursor(refcursor, data_sql text, header_sql text)
RETURNS refcursor
LANGUAGE plpgsql
AS $function$
DECLARE
  row RECORD;
  curs REFCURSOR;
  i INTEGER;
  y_axis TEXT;
  x_axis TEXT;
  value TEXT;
  h_value TEXT;
  header_cond TEXT;
  final_sql TEXT;
  js JSON;
BEGIN
  i := 1;
  EXECUTE 'SELECT row_to_json(_r.*) FROM (' ||  data_sql || ') AS _r' INTO js;
  FOR row IN SELECT * FROM json_each_text(js)                                     (1)
  LOOP
    IF (i=1) THEN y_axis := row.key;
      ELSEIF (i=2) THEN x_axis := row.key;
      ELSEIF (i=3) THEN value := row.key;
    END IF;
    i := i+1;
  END LOOP;
  FOR h_value IN EXECUTE header_sql                                              (2)
  LOOP
    header_cond := concat(header_cond,
      format(chr(10)||',min(case when %I=%L then %I::text end) as %I',x_axis,h_value,value,h_value));
  END LOOP;
  final_sql := format('SELECT %I %s FROM (select *,row_number() over() as rn from (%s) AS _c) as _d GROUP BY %I order by min(rn)', y_axis, header_cond,data_sql,y_axis);     (3)
  OPEN $1 FOR EXECUTE final_sql;                                                 (4)
  RETURN $1;
END
$function$;
