import psycopg2
from psycopg2 import Error
import matplotlib.pyplot as plt
import pandas as pd
try:
  sqlstmt = "SELECT * FROM cal_housing"
  conn = psycopg2.connect(dbname="hanser", user="postgres", password="postgres", host="localhost")
  data = pd.read_sql_query(sqlstmt, conn)
  data.plot(kind="scatter", x="longtitude", y="latiude",
    s=data['population']/100, label="population",
    c="median_house_value", cmap=plt.get_cmap("jet"),
    colorbar=True, alpha=0.4, figsize=(10,7),
	)
  plt.legend()
  plt.show()
except (Exception, Error) as error:
  print("Fehler: ", error)
finally:
  conn.close()  
