import psycopg2
from psycopg2 import Error
import pandas as pd
from sklearn.feature_extraction.text import CountVectorizer
try:
  cv = CountVectorizer(stop_words='english')
  sqlstmt = "SELECT bewertung FROM imdb"
  conn = psycopg2.connect(dbname="movdb", user="postgres", password="postgres", host="localhost")
  cursor = conn.cursor()
  cursor.execute(sqlstmt)
  rows = cursor.fetchall()
  df = pd.DataFrame(rows)
  npa = df.to_numpy()
  npaf = npa.flatten()
  bag = cv.fit_transform(npaf)
  voc = cv.vocabulary_
  for key, value in voc.items():
    cursor.execute("INSERT INTO word_dict VALUES (%s, %s)", (key, value))
  conn.commit()
except (Exception, Error) as error:
  print("Fehler: ", error)
finally:
  cursor.close()    
  conn.close()
